package com.engine.organization.wrapper;

import com.engine.common.util.ServiceUtil;
import com.engine.core.impl.Service;
import com.engine.organization.entity.staff.param.StaffPlanSearchParam;
import com.engine.organization.service.StaffPlanService;
import com.engine.organization.service.impl.StaffPlanServiceImpl;
import org.apache.ibatis.annotations.Param;
import weaver.hrm.User;

import java.util.Collection;
import java.util.Map;

/**
 * @description:
 * @author:dxfeng
 * @createTime: 2022/05/25
 * @version: 1.0
 */
public class StaffPlanWrapper extends Service {
    private StaffPlanService getStaffPlanService(User user) {
        return ServiceUtil.getService(StaffPlanServiceImpl.class, user);
    }

    /**
     * 编制方案列表
     *
     * @param params
     * @return
     */
    public Map<String, Object> listPage(StaffPlanSearchParam params) {
        return getStaffPlanService(user).listPage(params);
    }

    /**
     * 新增编制方案
     *
     * @param param
     * @return
     */
    public int saveStaffPlan(StaffPlanSearchParam param) {
        return getStaffPlanService(user).saveStaffPlan(param);
    }

    /**
     * 更新编制方案
     *
     * @param param
     * @return
     */
    public int updateStaffPlan(StaffPlanSearchParam param) {
        return getStaffPlanService(user).updateStaffPlan(param);
    }

    /**
     * 更新禁用标记
     *
     * @param params
     */
    public int updateForbiddenTagById(StaffPlanSearchParam params) {
        return getStaffPlanService(user).updateForbiddenTagById(params);
    }

    /**
     * 根据ID批量删除
     *
     * @param ids
     */
    public int deleteByIds(@Param("ids") Collection<Long> ids) {
        return getStaffPlanService(user).deleteByIds(ids);
    }

    /**
     * 获取搜索条件
     *
     * @param params
     * @return
     */
    public Map<String, Object> getSearchCondition(Map<String, Object> params) {
        return getStaffPlanService(user).getSearchCondition(params);
    }


    /**
     * 获取新增表单
     *
     * @param params
     * @return
     */
    public Map<String, Object> getForm(Map<String, Object> params) {
        return getStaffPlanService(user).getForm(params);
    }

    /**
     * 获取列表页面按钮信息
     *
     * @return
     */
    public Map<String, Object> getHasRight() {
        return getStaffPlanService(user).getHasRight();
    }
}
